Scriptname _CD_QuestScript extends Quest  

FormList Property _CD_ListFactions Auto
FormList Property _CD_ListGlobals Auto
FormList Property _CD_ListMsgsClear Auto
FormList Property _CD_ListMsgsFull Auto
FormList Property _CD_ListMsgsHire Auto

int GroupCount = 15

Function HirePerson(Actor Person, int HornType)
	int AliasIndex = GroupCount * HornType
	bool AliasAdded = false
	GlobalVariable HireCount = _CD_ListGlobals.GetAt(HornType) as GlobalVariable
	while(!AliasAdded && AliasIndex < GroupCount * (HornType + 1))
		ReferenceAlias ThisAlias = GetAlias(AliasIndex) as ReferenceAlias
		if(!ThisAlias.GetActorReference())
			AliasAdded = true
			ThisAlias.ForceRefTo(Person)
			Person.SetFactionRank(_CD_ListFactions.GetAt(HornType) as Faction, 0)
			HireCount.Mod(1)
			UpdateCurrentInstanceGlobal(HireCount)
			(_CD_ListMsgsHire.GetAt(AliasIndex) as Message).Show()
		else
			AliasIndex += 1
		endIf
	endWhile
	
	if(!AliasAdded)
		(_CD_ListMsgsFull.GetAt(HornType) as Message).Show()
	endIf
endFunction

Function ClearPerson(Actor Person, int HornType, bool DisplayMsg = true)
	int AliasIndex = GroupCount * HornType
	bool AliasRemoved = false
	GlobalVariable HireCount = _CD_ListGlobals.GetAt(HornType) as GlobalVariable
	while(!AliasRemoved && AliasIndex < GroupCount * (HornType + 1))
		ReferenceAlias ThisAlias = GetAlias(AliasIndex) as ReferenceAlias
		if(ThisAlias.GetActorReference() == Person)
			AliasRemoved = true
			HireCount.Mod(-1)
			UpdateCurrentInstanceGlobal(HireCount)
			if(DisplayMsg)
				(_CD_ListMsgsClear.GetAt(AliasIndex) as Message).Show()
			endIf
			Person.SetFactionRank(_CD_ListFactions.GetAt(HornType) as Faction, 0)
			ThisAlias.Clear()
			Person.EvaluatePackage()
			SetObjectiveDisplayed(AliasIndex, false)
		else
			AliasIndex += 1
		endIf
	endWhile
endFunction

Function DismissPerson(Actor Person, int HornType)
	int AliasIndex = GroupCount * HornType
	bool AliasDismissed = false
	while(!AliasDismissed && AliasIndex < GroupCount * (HornType + 1))
		ReferenceAlias ThisAlias = GetAlias(AliasIndex) as ReferenceAlias
		if(ThisAlias.GetActorReference() == Person)
			AliasDismissed = true
			Person.SetFactionRank(_CD_ListFactions.GetAt(HornType) as Faction, 0)
			Person.EvaluatePackage()
			SetObjectiveDisplayed(AliasIndex, false)
		else
			AliasIndex += 1
		endIf
	endWhile
endFunction

Function BlowHorn(int HornType)
	int AliasIndex = GroupCount * HornType
	Faction HornFaction = _CD_ListFactions.GetAt(HornType) as Faction
	while(AliasIndex < GroupCount * (HornType + 1))
		ReferenceAlias ThisAlias = GetAlias(AliasIndex) as ReferenceAlias
		Actor Person = ThisAlias.GetActorReference()
		if(Person)
			Person.SetFactionRank(HornFaction, 1)
			Person.EvaluatePackage()
			SetObjectiveDisplayed(AliasIndex, true)
			AliasIndex += 1
		endIf
	endWhile
endFunction